//Millie "BluEyes" Prower - a character mod by PikaJade

//Sprites edited from vanilla SRB2
//Additional sound(s) from Sonic '06
//Seashell color from Lamonite's "Xtra Shades" https://mb.srb2.org/addons/xtra-shades.5903/
//Oof sprite from Frostiikin's XMomentum

rawset(_G,"J_PlayerCanUseAbility",function(p)
	local mo = p.mo
	
	if P_PlayerInPain(p)
	or p.pflags & PF_SLIDING
	or p.powers[pw_carry]
	or p.powers[pw_nocontrol]
	or p.exiting
	or p.pstate == PST_DEAD
		return false end
	return true
end)

rawset(_G,"J_ModifyThrust",function(n,mo)
	local returning = n
	if mo.eflags & MFE_UNDERWATER
		returning = $/2
	end
	if mo.player
	and (mo.player.powers[pw_sneakers]
	or mo.player.powers[pw_super])
		returning = $*2
	end
	
	returning = FixedMul($,mo.scale)
	
	return returning
end)

rawset(_G,"J_GetVectorAngle",function(x,y)
	return R_PointToAngle2(0,0,x,y)
end)

rawset(_G,"J_GetMobjThrustSpeed",function(mo)
	return FixedHypot(mo.momx,mo.momy)
end)

rawset(_G,"J_GetMobjThrustAngle",function(mo)
	return J_GetVectorAngle(mo.momx,mo.momy)
end)

rawset(_G,"J_IsPlayerSkin",function(p,skin)
	if p
	and p.mo
	and p.mo.valid
	and p.mo.skin == skin
		return true end
	return false
end)

rawset(_G,"J_GetInputAngle",function(cmd)
	return (cmd.angleturn*FRACUNIT) + J_GetVectorAngle(cmd.forwardmove*FRACUNIT,-cmd.sidemove*FRACUNIT)
end)

rawset(_G,"J_GetInputMagnitude",function(cmd)
	return FixedHypot(cmd.forwardmove,cmd.sidemove)*FRACUNIT/50
end)

rawset(_G,"J_XOR",function(a,b)
	if a and b
		return false end
	if a or b
		return true end
	return false
end)

addHook("PlayerThink",function(p)
	if p.jprevbuttons
		p.jbuttonspressed = (p.jprevbuttons^p.cmd.buttons) & p.cmd.buttons
	end
	p.jprevbuttons = p.cmd.buttons
end)