local thoklimit = 5
local mahudscale = {}

freeslot(
	"S_PLAY_MAFLY",
	"S_PLAY_MATTHOK",
	"sfx_talspn",
	"sfx_flybur",
	"sfx_matire",
	"sfx_maheli",
	"SKINCOLOR_SEASHELL"
)

sfxinfo[sfx_flybur] = {
	singular = true,
	caption = "Flight"
}

sfxinfo[sfx_talspn] = {
	singular = true,
	caption = "Spin attack"
}

sfxinfo[sfx_matire] = {
	singular = true,
	caption = "Tired flight"
}

sfxinfo[sfx_maheli] = {
	caption = "Flight"
}

skincolors[SKINCOLOR_SEASHELL] = {
    name = "Seashell",
    ramp = {80,82,83,72,73,50,51,51,53,54,56,57,59,62,44,45},
    invcolor = SKINCOLOR_BLUEBELL,
    invshade = 5,
    chatcolor = V_YELLOWMAP,
    accessible = true
}

local A_MATailsFly = function(mo,v1,v2)
	if not mo.player
		return end
	
	if mo.player.mathoks >= thoklimit
		mo.sprite2 = SPR2_TIRE
	elseif J_XOR(mo.momz < 0, mo.eflags & MFE_VERTICALFLIP)
		mo.state = S_PLAY_JUMP
	end
end

local A_MATailsThok = function(mo,v1,v2)
	if not mo.player
		return end
	
	if FixedHypot(mo.momx,mo.momy) < FixedMul(mo.player.actionspd/2,mo.scale)
		mo.state = S_PLAY_JUMP
		return
	end
	
	mo.tics = max(1,(thoklimit - (J_GetMobjThrustSpeed(mo) / FixedMul(mo.player.actionspd,mo.scale)))/2)
end

states[S_PLAY_MAFLY] = {
	sprite = SPR_PLAY,
	frame = SPR2_FLY,
	nextstate = S_PLAY_MAFLY,
	tics = 1,
	action = A_MATailsFly
}

states[S_PLAY_MATTHOK] = {
	sprite = SPR_PLAY,
	frame = SPR2_GLID,
	nextstate = S_PLAY_MATTHOK,
	tics = 1,
	action = A_MATailsThok
}

local hudsize = CV_RegisterVar({
	name = "be_hudscale",
	defaultvalue = "0.75",
	flags = CV_FLOAT,
	PossibleValue = {MIN = 0, MAX = 2*FU}
})

local hudtrans = CV_RegisterVar({
	name = "be_hudtrans",
	defaultvalue = "Half",
	flags = 0,
	PossibleValue = {
		Full = V_HUDTRANS,
		Half = V_HUDTRANSHALF
	}
})

local hudanim = CV_RegisterVar({
	name = "be_hudanimation",
	defaultvalue = "On",
	flags = 0,
	PossibleValue = CV_OnOff
})

addHook("PlayerSpawn",function(p)
	if skins[p.skin].name != "matails"
		return end
	p.mathoks = 0
end)

addHook("PlayerThink",function(p)
	if not J_IsPlayerSkin(p,"matails")
		return end
	local mo = p.mo
	local cmd = p.cmd
	
	if p.mathoks == nil
		p.mathoks = 0
	end
	
	if (~cmd.buttons) & BT_JUMP
	and p.mathoks < thoklimit
		p.pflags = $&~PF_THOKKED
	end
	
	if mo.state == S_PLAY_SPRING
	or P_PlayerInPain(p)
	or p.playerstate != PST_LIVE
		p.mathoks = 0
	end
	
	if P_IsObjectOnGround(mo)
	or p.powers[pw_carry]
		if p.mathoks > thoklimit
		and P_IsObjectOnGround(mo)
		and p.shouldland
			mo.state = S_PLAY_GLIDE_LANDING
			//mo.tics = $-2
			//P_InstaThrust(mo,J_GetMobjThrustAngle(mo),J_GetMobjThrustSpeed(mo)/2)
			S_StartSound(mo,sfx_s3k4c)
			p.pflags = $&~PF_SPINNING
		end
		p.mathoks = 0
	end
	
	p.shouldland = mo.state == S_PLAY_MATTHOK
	
	if p.powers[pw_carry] == CR_MINECART
		if cmd.buttons & BT_SPIN
			mo.sprite2 = SPR2_LAND
		elseif mo.sprite2 == SPR2_LAND
			mo.sprite2 = SPR2_STND
		end
	end
	
	if p.mathoks
		p.charflags = $|SF_NOSHIELDABILITY
		if not p.powers[pw_super]
			p.charflags = $&~ SF_SUPER
		end
	else
		p.charflags = ($&~SF_NOSHIELDABILITY)|SF_SUPER
	end
end)

addHook("AbilitySpecial",function(p)
	if not J_IsPlayerSkin(p,"matails")
	or not J_PlayerCanUseAbility(p)
	or p.mathoks >= thoklimit
		return end
		
	if p.mo.eflags & MFE_VERTICALFLIP
		p.mo.momz = min($,0)
	else
		p.mo.momz = max($,0)
	end
	
	P_SetObjectMomZ(p.mo,max(p.actionspd*2/3,p.actionspd*(thoklimit-p.mathoks)/thoklimit),true)
	
	if abs(p.mo.momz) > max(p.actionspd*2/3,p.actionspd*(thoklimit-p.mathoks)/thoklimit) * 2
		P_SetObjectMomZ(p.mo,max(p.actionspd*2/3,p.actionspd*(thoklimit-p.mathoks)/thoklimit) * 2,false)
	end
	
	if p.mo.eflags & MFE_UNDERWATER
		p.mo.momz = $/2
	end
	
	//P_InstaThrust(p.mo,J_GetInputAngle(p.cmd),FixedHypot(p.mo.momx,p.mo.momy)/2)
	//local thrust = p.actionspd*FixedHypot(p.cmd.forwardmove,p.cmd.sidemove)/50
	local thrust = J_ModifyThrust(FixedMul(p.actionspd,J_GetInputMagnitude(p.cmd)),p.mo)
	
	P_Thrust(p.mo,J_GetInputAngle(p.cmd),thrust)
	if FixedHypot(p.mo.momx,p.mo.momy) > thrust*2
		P_InstaThrust(p.mo,J_GetInputAngle(p.cmd),thrust*2)
	end
	
	p.mo.state = S_PLAY_MAFLY
	p.pflags = $&~(PF_SPINNING|PF_STARTJUMP)
	
	S_StopSoundByID(p.mo,sfx_flybur)
	if p.mathoks == thoklimit-1
		S_StartSound(p.mo,sfx_matire)
	else
		S_StartSound(p.mo,sfx_flybur)
	end
	
	p.mathoks = $+1
end)

addHook("JumpSpinSpecial",function(p)
	if not J_IsPlayerSkin(p,"matails")
	or not J_PlayerCanUseAbility(p)
	or p.mathoks > thoklimit
	or p.mathoks == 0
		return end
		
	P_InstaThrust(p.mo,p.mo.angle,J_ModifyThrust(max(J_GetMobjThrustSpeed(p.mo),p.actionspd*p.mathoks,p.actionspd*2),p.mo))
	P_SetObjectMomZ(p.mo,FixedDiv(J_ModifyThrust(2*p.mathoks*FU,p.mo),p.mo.scale),false)
	p.mathoks = thoklimit + 1
	p.mo.state = S_PLAY_MATTHOK
	S_StopSoundByID(p.mo,sfx_flybur)
	S_StopSoundByID(p.mo,sfx_matire)
	S_StartSound(p.mo,sfx_talspn)
end)

addHook("PostThinkFrame",function()
	for p in players.iterate
		if J_IsPlayerSkin(p,"matails") 
		and p.followmobj and p.followmobj.valid
			local fmo = p.followmobj
			fmo.scale = p.mo.scale*11/10
			P_MoveOrigin(fmo,fmo.x,fmo.y,fmo.z-2*p.mo.scale)
			
			if p.mo.sprite2 == SPR2_LAND
			and p.followmobj.state == S_INVISIBLE
				p.followmobj.state = S_TAILSOVERLAY_EDGE
			end
		end
	end
end)

hud.add(function(v,p,cam)
	if not (gamestate == GS_LEVEL
	and p.mo and p.mo.valid
	and p.mo.skin == "matails")
		return end
		
	local frames = 4
		
	if mahudscale[p] == nil
		mahudscale[p] = 0
	elseif p.exiting
	or P_IsObjectOnGround(p.mo)
	or P_PlayerInPain(p)
	or p.playerstate != PST_LIVE
	or (p.mathoks and p.mathoks > thoklimit)
	or ~p.pflags & PF_JUMPED
		if not hudanim.value
			return end
		mahudscale[p] = max(0,$-(FRACUNIT/(frames*2)))
	else
		mahudscale[p] = min(FRACUNIT/2,$+(FRACUNIT/(frames*2)))
	end
	
	if mahudscale[p] <= 0
		return end
		
	if not hudanim.value
		mahudscale[p] = FRACUNIT/2
	end
	
	local col = p.skincolor
	local patchname = "TMETER" .. tostring(p.mathoks)
	if p.powers[pw_super]
		col = p.mo.color
	end
	if not v.patchExists(patchname)
		patchname = "TMETER5"
	end
	--v.drawScaled(162*FRACUNIT,102*FRACUNIT,mahudscale[p]/2,v.cachePatch(patchname),V_PERPLAYER|V_HUDTRANSHALF,v.getColormap(TC_ALLWHITE,SKINCOLOR_WHITE))
	v.drawScaled(160*FRACUNIT,100*FRACUNIT,FixedMul(mahudscale[p],hudsize.value),v.cachePatch(patchname),V_PERPLAYER|hudtrans.value,v.getColormap(nil,col))
end)

if not PlayerAnimInfo
	rawset(_G, "PlayerAnimInfo", {})
end

PlayerAnimInfo["matails"] = {
	["runFrames"] = {-1},
	["dashFrames"] = {-1},
	["walkFrames"] = {3, 7},
	["waitFrames"] = {-1},
	["milnekickFrames"] = {0, 4},
	["run"] = false,
	["dash"] = false,
	["walk"] = true,
	["idle"] = true,
	["wait"] = false,
	["milnekick"] = true,
	["superRun"] = false,
	["superDash"] = false,
	["superWalk"] = true,
	["superIdle"] = true,
	["superWait"] = false
}