freeslot(
	"S_MAWIND",
	"MT_MAWIND"
)

states[S_MAWIND] = {
	sprite = SPR_DUST,
	frame = A|FF_TRANS50|FF_ANIMATE,
	tics = 1,
	var1 = 3,
	var2 = 10,
	nextstate = S_MAWIND
}

mobjinfo[MT_MAWIND] = {
	spawnstate = S_MAWIND,
	flags = MF_NOCLIP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

local battled = false

addHook("MobjSpawn",function(mo)
	mo.fuse = 25-P_RandomKey(10)
	mo.fradius = 64+P_RandomKey(16)
	mo.voff = 16-P_RandomKey(32)
end,MT_MAWIND)

addHook("MobjThinker",function(mo)
	mo.fradius = $*19/20
	mo.voff = $-2
	A_Custom3DRotate(mo,(mo.voff*FRACUNIT)|mo.fradius,320*FRACUNIT)
	mo.scale = FRACUNIT
end,MT_MAWIND)

addHook("ThinkFrame",function()
	if CBW_Battle
	and not battled
		battled = true
		local btl = CBW_Battle
		
		local tailsBattleAction = function(mo,doact)
			local p = mo.player
			
			p.actiontext = "Crosswind (Hold)"
			p.actionrings = 20
			
			local doaction = doact
			if doaction == 0
			and p.actiontime
			and p.actiontime < 7
				doaction = 2
			end
			
			if (doaction == 0
			or p.actiontime >= TICRATE/2)
			and p.actiontime
				mo.state = S_PLAY_SPRING
				CBW_Battle.PayRings(p,20,true)
				CBW_Battle.ApplyCooldown(p,max(5*TICRATE,p.actiontime*25),true)
				P_InstaThrust(mo,mo.angle,0)
				p.actiontime = 0
				S_StopSoundByID(mo,sfx_s3kces)
				S_StartSound(mo,sfx_wdjump)
			elseif doaction == 1
				p.actiontime = 1
				p.mathoks = 5
				mo.momz = 0
				S_StartSound(mo,sfx_s3k4b)
			elseif doaction == 2
				mo.momx = $/2
				mo.momy = $/2
				p.pflags = ($&~(PF_SPINNING|PF_STARTJUMP|PF_THOKKED))|PF_JUMPED
			
				for i = 1,3 do
					local wind = P_SpawnMobj(mo.x,mo.y,mo.z,MT_MAWIND)
					wind.target = mo
					wind.scale = 0
				end
				
				p.actiontime = $+1
				if not (p.actiontime % 5)
					p.mathoks = max($-1,0)
				end
				
				mo.state = S_PLAY_ROLL
				P_SetObjectMomZ(mo,FRACUNIT*2,true)
			end
		end
		
		local tailsPriorityFunc = function(p)
			if p.actiontime then
				btl.SetPriority(p,1,3,nil,3,3,"Crosswind")
			end
		end
		
		btl.SkinVars["matails"] = {		
			weight = 100,
			flags = SKINVARS_GUARD|SKINVARS_NOSPINSHIELD,
			special = tailsBattleAction,
			func_priority_ext = tailsPriorityFunc
		}
	end
end)